<?php
namespace Folha\Repositories;

class FpaCalculofolha extends \Doctrine\ORM\EntityRepository
{
    const DECIMO_TERCEIRO = 110;

    /**
     * Busca no banco de dados as horas extras
     * @param $nrvinculom
     * @param $nrorg
     * @param $dataInicial
     * @param $dataFinal
     * @return array|bool
     */
    public static function getHorasExtrasRais($nrvinculom, $nrorg, $dataInicial, $dataFinal, $grupoIncide, $tipoIncide = 80)
    {
        $sql = <<<SQL
SELECT
    NVL(ROUND(JANEIRO-0.0000001), 0)     AS JANEIRO,
    NVL(ROUND(FEVEREIRO-0.0000001), 0)   AS FEVEREIRO,
    NVL(ROUND(MARÇO-0.0000001), 0)       AS MARÇO,
    NVL(ROUND(ABRIL-0.0000001), 0)       AS ABRIL,
    NVL(ROUND(MAIO-0.0000001), 0)        AS MAIO,
    NVL(ROUND(JUNHO-0.0000001), 0)       AS JUNHO,
    NVL(ROUND(JULHO-0.0000001), 0)       AS JULHO,
    NVL(ROUND(AGOSTO-0.0000001), 0)      AS AGOSTO,
    NVL(ROUND(SETEMBRO-0.0000001), 0)    AS SETEMBRO,
    NVL(ROUND(OUTUBRO-0.0000001), 0)     AS OUTUBRO,
    NVL(ROUND(NOVEMBRO-0.0000001), 0)    AS NOVEMBRO,
    NVL(ROUND(DEZEMBRO-0.0000001), 0)    AS DEZEMBRO

FROM(
--     SELECT FPA_ITECALCFOLHA.VRREFFOLHA,
--         TO_CHAR(FPA_CALCULOFOLHA.DTOCORRENCIA, 'MM') DTOCORRENCIA
--     FROM FPA_CALCULOFOLHA
--     INNER JOIN FPA_ITECALCFOLHA
--         ON FPA_ITECALCFOLHA.NRCALCULOFOLHA = FPA_CALCULOFOLHA.NRCALCULOFOLHA
--         AND FPA_ITECALCFOLHA.NRORG = FPA_CALCULOFOLHA.NRORG
--     WHERE FPA_ITECALCFOLHA.NREVENTOM IN (90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 70, 71, 72, 73, 74, 80, 81, 82, 83, 84)
--         AND FPA_CALCULOFOLHA.DTOCORRENCIA BETWEEN '$dataInicial' AND '$dataInicial'
--         AND FPA_CALCULOFOLHA.NROCORRECAL = 1
--         AND FPA_CALCULOFOLHA.NRTIPOMOVIMENT = 1
--         AND FPA_CALCULOFOLHA.NRTPMODALIDCAL = 1
--         AND FPA_ITECALCFOLHA.NRVINCULOM = $nrvinculom
--         AND FPA_ITECALCFOLHA.NRORG = $nrorg

SELECT
    FPA_ITECALCFOLHA.VRREFFOLHA,
    TO_CHAR(FPA_CALCULOFOLHA.DTOCORRENCIA, 'MM')DTOCORRENCIA
FROM FPA_INCIDEVENTO
INNER JOIN FPA_GRPITEM
    ON FPA_INCIDEVENTO.NRTIPOINCIDE = FPA_GRPITEM.NRTIPOINCIDE
INNER JOIN FPA_ITECALCFOLHA
    ON FPA_ITECALCFOLHA.NREVENTOM = FPA_INCIDEVENTO.NREVENTOM
INNER JOIN FPA_CALCULOFOLHA
    ON FPA_ITECALCFOLHA.NRCALCULOFOLHA = FPA_CALCULOFOLHA.NRCALCULOFOLHA
    AND FPA_ITECALCFOLHA.NRORG = FPA_CALCULOFOLHA.NRORG
WHERE FPA_GRPITEM.NRGRPINCIDE = $grupoIncide
    AND FPA_INCIDEVENTO.NRTIPOINCIDE = $tipoIncide
    AND FPA_CALCULOFOLHA.DTOCORRENCIA BETWEEN TO_DATE('$dataInicial') AND TO_DATE('$dataFinal')
    AND FPA_CALCULOFOLHA.NRTIPOMOVIMENT = 1
    AND FPA_CALCULOFOLHA.NRTPMODALIDCAL = 1
    AND FPA_CALCULOFOLHA.NROCORRECAL = 1
    AND FPA_ITECALCFOLHA.NRVINCULOM = $nrvinculom
    AND FPA_ITECALCFOLHA.NRORG = $nrorg

) PIVOT (
    SUM(VRREFFOLHA)
    FOR DTOCORRENCIA IN (
        '01'    AS  JANEIRO,
        '02'    AS  FEVEREIRO,
        '03'    AS  MARÇO,
        '04'    AS  ABRIL,
        '05'    AS  MAIO,
        '06'    AS  JUNHO,
        '07'    AS  JULHO,
        '08'    AS  AGOSTO,
        '09'    AS  SETEMBRO,
        '10'    AS  OUTUBRO,
        '11'    AS  NOVEMBRO,
        '12'    AS  DEZEMBRO))
SQL;

        $result = \Setforms2\Shared\Connection::getInstance()->fetchAll($sql);
        return ($result)?$result[0]:false;
    }

    /**
     * Busca as contribuições no banco de dados de acordo com cada pessoa
     * @param $nrvinculom
     * @param $nrorg
     * @param array $eventos
     * @param $dataInicio
     * @param $dataFinal
     * @return array|bool
     */
    public static function getContrubuicoes($nrvinculom, $nrorg, $eventos = array(), $dataInicio, $dataFinal)
    {
        if(is_array($eventos)){
            $eventos = implode(' ,', $eventos);
        }

        $sql = <<< SQL
SELECT SUM(FPA_ITECALCFOLHA.VREVENTOFOLHA) VREVENTOFOLHA,
    FPA_ITECALCFOLHA.NRVINCULOM,
    FPA_ITECALCFOLHA.NRORG,
    ESTRUTURAH.CDCNPJESTRUT
FROM FPA_CALCULOFOLHA
INNER JOIN FPA_ITECALCFOLHA
    ON FPA_ITECALCFOLHA.NRCALCULOFOLHA = FPA_CALCULOFOLHA.NRCALCULOFOLHA
    AND FPA_ITECALCFOLHA.NRORG = FPA_CALCULOFOLHA.NRORG
INNER JOIN FPA_EVENTOH
    ON FPA_ITECALCFOLHA.NREVENTOM = FPA_EVENTOH.NREVENTOM
INNER JOIN GPE_VINCULOH
    ON GPE_VINCULOH.NRVINCULOM = FPA_ITECALCFOLHA.NRVINCULOM
    AND GPE_VINCULOH.NRORG = FPA_ITECALCFOLHA.NRORG
    AND GPE_VINCULOH.DTMESCOMPETENC = (SELECT MAX(MAX_HISTORICO.DTMESCOMPETENC) DTMESCOMPETENC
                                        FROM GPE_VINCULOH MAX_HISTORICO
                                        WHERE MAX_HISTORICO.NRVINCULOM = GPE_VINCULOH.NRVINCULOM
                                        AND MAX_HISTORICO.NRORG = $nrorg
                                        and MAX_HISTORICO.DTMESCOMPETENC <= '$dataFinal')
INNER JOIN ESTRUTURAH
    ON GPE_VINCULOH.NRESTRUTSIND = ESTRUTURAH.NRESTRUTURAM
    AND GPE_VINCULOH.NRORG = ESTRUTURAH.NRORG
    AND ESTRUTURAH.DTMESCOMPETENC = ( SELECT MAX(MAX_HISTORICO.DTMESCOMPETENC) DTMESCOMPETENC
                                      FROM ESTRUTURAH MAX_HISTORICO
                                      WHERE MAX_HISTORICO.NRESTRUTURAM = ESTRUTURAH.NRESTRUTURAM
                                        AND MAX_HISTORICO.NRORG = $nrorg
                                        AND MAX_HISTORICO.DTMESCOMPETENC <= '$dataFinal')
WHERE FPA_CALCULOFOLHA.NRTPMODALIDCAL = 1
    AND FPA_CALCULOFOLHA.NRTIPOMOVIMENT = 1
    AND FPA_CALCULOFOLHA.NROCORRECAL = 1
    AND FPA_CALCULOFOLHA.DTOCORRENCIA BETWEEN '$dataInicio' AND '$dataFinal'
    AND FPA_ITECALCFOLHA.NREVENTOM IN ($eventos)
    AND FPA_ITECALCFOLHA.NRVINCULOM = $nrvinculom
    AND FPA_ITECALCFOLHA.NRORG = $nrorg

GROUP BY FPA_ITECALCFOLHA.NRVINCULOM,
    FPA_ITECALCFOLHA.NRORG,
    ESTRUTURAH.CDCNPJESTRUT

-- ORDER BY FPA_ITECALCFOLHA.NRVINCULOM, FPA_CALCULOFOLHA.DTOCORRENCIA
SQL;

        $result = \Setforms2\Shared\Connection::getInstance()->fetchAll($sql);
        return ($result)?$result:false;

    }

    public static function getDecimoTerceiro($nrvinculom, $nrorg, $inicio, $final, $nreventom = 110)
    {
        $sql = <<<SQL
SELECT
    SUM(FPA_ITECALCFOLHA.VREVENTOFOLHA) VALOR_TOTAL,
    TO_CHAR(DATA_OCORRENCIA.DTOCORRENCIA, 'MM') DTOCORRENCIA,
    FPA_ITECALCFOLHA.NRVINCULOM,
    FPA_ITECALCFOLHA.NRORG
FROM FPA_CALCULOFOLHA
INNER JOIN FPA_ITECALCFOLHA
    ON FPA_ITECALCFOLHA.NRCALCULOFOLHA = FPA_CALCULOFOLHA.NRCALCULOFOLHA
    AND FPA_ITECALCFOLHA.NRORG = FPA_CALCULOFOLHA.NRORG
INNER JOIN (SELECT MAX(FPA_ITECALCFOLHA.DTOCORRENCIA) DTOCORRENCIA,
                NREVENTOM,
                NRVINCULOM,
                NRORG
            FROM FPA_ITECALCFOLHA
            GROUP BY NREVENTOM,
                NRVINCULOM,
                NRORG) DATA_OCORRENCIA
    ON DATA_OCORRENCIA.NRORG = FPA_CALCULOFOLHA.NRORG
    AND DATA_OCORRENCIA.NRVINCULOM = FPA_ITECALCFOLHA.NRVINCULOM
    AND DATA_OCORRENCIA.NREVENTOM = FPA_ITECALCFOLHA.NREVENTOM
WHERE FPA_CALCULOFOLHA.DTOCORRENCIA BETWEEN '$inicio' AND '$final'
    AND FPA_ITECALCFOLHA.NREVENTOM IN ($nreventom)
    AND FPA_CALCULOFOLHA.NRTPMODALIDCAL = 1
    AND FPA_CALCULOFOLHA.NROCORRECAL = 1
    AND FPA_CALCULOFOLHA.NRTIPOMOVIMENT = 4
    AND FPA_ITECALCFOLHA.NRVINCULOM = $nrvinculom
    AND FPA_ITECALCFOLHA.NRORG = $nrorg

GROUP BY  FPA_ITECALCFOLHA.NRVINCULOM,
    FPA_ITECALCFOLHA.NRORG,
    DATA_OCORRENCIA.DTOCORRENCIA
SQL;


        $result = \Setforms2\Shared\Connection::getInstance()->fetchAll($sql);
        $result = $result[0];

        if($nreventom == self::DECIMO_TERCEIRO ){
            $sql = <<<SQL
SELECT
    SUM(FPA_ITECALCFOLHA.VREVENTOFOLHA) VALOR_TOTAL,
    TO_CHAR(DATA_OCORRENCIA.DTOCORRENCIA, 'MM') DTOCORRENCIA,
    FPA_ITECALCFOLHA.NRVINCULOM,
    FPA_ITECALCFOLHA.NRORG
FROM FPA_CALCULOFOLHA
INNER JOIN FPA_ITECALCFOLHA
    ON FPA_ITECALCFOLHA.NRCALCULOFOLHA = FPA_CALCULOFOLHA.NRCALCULOFOLHA
    AND FPA_ITECALCFOLHA.NRORG = FPA_CALCULOFOLHA.NRORG
INNER JOIN (SELECT MAX(FPA_ITECALCFOLHA.DTOCORRENCIA) DTOCORRENCIA,
                NREVENTOM,
                NRVINCULOM,
                NRORG
            FROM FPA_ITECALCFOLHA
            GROUP BY NREVENTOM,
                NRVINCULOM,
                NRORG) DATA_OCORRENCIA
    ON DATA_OCORRENCIA.NRORG = FPA_CALCULOFOLHA.NRORG
    AND DATA_OCORRENCIA.NRVINCULOM = FPA_ITECALCFOLHA.NRVINCULOM
    AND DATA_OCORRENCIA.NREVENTOM = FPA_ITECALCFOLHA.NREVENTOM
WHERE FPA_CALCULOFOLHA.DTOCORRENCIA BETWEEN '$inicio' AND '$final'
    AND FPA_ITECALCFOLHA.NREVENTOM IN (1500)
    AND FPA_CALCULOFOLHA.NRTPMODALIDCAL = 1
    AND FPA_CALCULOFOLHA.NROCORRECAL = 1
    AND FPA_CALCULOFOLHA.NRTIPOMOVIMENT = 4
    AND FPA_ITECALCFOLHA.NRVINCULOM = $nrvinculom
    AND FPA_ITECALCFOLHA.NRORG = $nrorg

GROUP BY  FPA_ITECALCFOLHA.NRVINCULOM,
    FPA_ITECALCFOLHA.NRORG,
    DATA_OCORRENCIA.DTOCORRENCIA
SQL;
            $debito = \Setforms2\Shared\Connection::getInstance()->fetchAll($sql);
            $result['VALOR_TOTAL'] -= $debito['VALOR_TOTAL'];
        }

        return ($result)?$result:false;

    }

    public static function getAvisoPrevioIndenizado($nrvinculom, $nrorg, $data_inicial, $data_final, $data_recisao, $data_avisoPrevio)
    {
        if(is_null($data_recisao))
            return false;
        else{
            $data_recisao = substr($data_recisao, 0, 10);
        }

        if(is_null($data_avisoPrevio))
            return false;
        else{
            $data_avisoPrevio = substr($data_avisoPrevio, 0, 10);
        }

        $sql = <<<SQL
SELECT
        DISTINCT(GPE_VINCULOM.NRVINCULOM),
        GPE_VINCULOM.NMVINCULOM,
        FPA_ITECALCFOLHA.VREVENTOFOLHA,
        GPE_VINCULOM.DTRESCISAOVINC,
        GPE_VINCULOM.DTAVISOPREVIO,
        GPE_VINCULOM.NRORG

    FROM GPE_VINCULOM
    INNER JOIN FPA_ITECALCFOLHA
        ON GPE_VINCULOM.NRVINCULOM = FPA_ITECALCFOLHA.NRVINCULOM
        AND GPE_VINCULOM.NRORG = FPA_ITECALCFOLHA.NRORG
    INNER JOIN FPA_CALCULOFOLHA
        ON FPA_ITECALCFOLHA.NRCALCULOFOLHA = FPA_CALCULOFOLHA.NRCALCULOFOLHA
        AND FPA_ITECALCFOLHA.NRORG = FPA_CALCULOFOLHA.NRORG
    WHERE FPA_CALCULOFOLHA.DTOCORRENCIA BETWEEN TO_DATE('$data_inicial') AND TO_DATE('$data_final')
        AND FPA_CALCULOFOLHA.NROCORRECAL = 1
        AND FPA_CALCULOFOLHA.NRTIPOMOVIMENT = 9
        AND FPA_CALCULOFOLHA.NRTPMODALIDCAL = 1
        AND FPA_ITECALCFOLHA.IDEVENDEMONCALC = 'N'
        AND GPE_VINCULOM.NRVINCULOM = $nrvinculom
        AND GPE_VINCULOM.NRORG = $nrorg
        AND GPE_VINCULOM.DTRESCISAOVINC = '$data_recisao'
        AND GPE_VINCULOM.DTAVISOPREVIO = '$data_avisoPrevio'
        AND FPA_ITECALCFOLHA.NREVENTOM = 190
        --AND GPE_VINCULOM.DTRESCISAOVINC = GPE_VINCULOM.DTAVISOPREVIO
SQL;

        $result = \Setforms2\Shared\Connection::getInstance()->fetchAll($sql);
        return ($result)?$result:false;

    }

    public static function getFeriasIndenizada($nrvinculom, $nrorg, $data_inicial, $data_final, $nreventom, $nrtipomoviment)
    {
        $sql = <<<SQL
SELECT SUM(FPA_ITECALCFOLHA.VREVENTOFOLHA) VALOR,
    FPA_ITECALCFOLHA.NRVINCULOM,
    FPA_ITECALCFOLHA.NRORG
FROM FPA_CALCULOFOLHA
INNER JOIN FPA_ITECALCFOLHA
    ON FPA_ITECALCFOLHA.NRCALCULOFOLHA = FPA_CALCULOFOLHA.NRCALCULOFOLHA
    AND FPA_ITECALCFOLHA.NRORG = FPA_CALCULOFOLHA.NRORG
WHERE FPA_ITECALCFOLHA.NREVENTOM IN ($nreventom) --(570, 515, 510, 270, 275, 505, 500)
    AND FPA_CALCULOFOLHA.NRTIPOMOVIMENT IN ($nrtipomoviment) --( 1, 5, 6, 9)
    AND FPA_CALCULOFOLHA.NRTPMODALIDCAL = 1
    AND FPA_CALCULOFOLHA.NROCORRECAL = 1
    AND (FPA_CALCULOFOLHA.DTOCORRENCIA BETWEEN TO_DATE('$data_inicial') AND TO_DATE('$data_final'))
    AND FPA_ITECALCFOLHA.NRVINCULOM = $nrvinculom
    AND FPA_ITECALCFOLHA.NRORG = $nrorg
GROUP BY FPA_ITECALCFOLHA.NRVINCULOM,
    FPA_ITECALCFOLHA.NRORG
SQL;

        $result = \Setforms2\Shared\Connection::getInstance()->fetchAll($sql);
        return ($result)?$result:false;

    }

    public static function getGratificacoes($nrvinculom, $nrorg, $data_inicial, $data_final, $nreventom, $nrtipomoviment)
    {
        $sql = <<<SQL
SELECT SUM(FPA_ITECALCFOLHA.VREVENTOFOLHA)VALOR,
    COUNT(FPA_CALCULOFOLHA.DTOCORRENCIA) QUANT_MESES,
    FPA_ITECALCFOLHA.NRVINCULOM,
    FPA_ITECALCFOLHA.NRORG
FROM FPA_CALCULOFOLHA
INNER JOIN FPA_ITECALCFOLHA
    ON FPA_ITECALCFOLHA.NRCALCULOFOLHA = FPA_CALCULOFOLHA.NRCALCULOFOLHA
    AND FPA_ITECALCFOLHA.NRORG = FPA_CALCULOFOLHA.NRORG
WHERE FPA_ITECALCFOLHA.NREVENTOM IN ($nreventom) --(140, 150, 175, 160, 170)
    AND FPA_CALCULOFOLHA.NRTIPOMOVIMENT IN ($nrtipomoviment) --( 1, 5, 6, 9)
    AND FPA_CALCULOFOLHA.NRTPMODALIDCAL = 1
    AND FPA_CALCULOFOLHA.NROCORRECAL = 1
    AND (FPA_CALCULOFOLHA.DTOCORRENCIA BETWEEN '$data_inicial' AND '$data_final')
    AND FPA_ITECALCFOLHA.NRVINCULOM = $nrvinculom
    AND FPA_ITECALCFOLHA.NRORG = $nrorg
GROUP BY FPA_ITECALCFOLHA.NRVINCULOM,
    FPA_ITECALCFOLHA.NRORG
SQL;

        $result = \Setforms2\Shared\Connection::getInstance()->fetchAll($sql);
        return ($result)?$result:false;

    }

    public static function getDissidio($nrvinculom, $nrorg, $data_inicial, $data_final)
    {
        $sql = <<<SQL
SELECT GPE_ALTESALARIO.VRSALARIO,
    GPE_ALTESALARIO.VRDIFERENCAREAL,
    (GPE_ALTESALARIO.VRSALARIO*(GPE_ALTESALARIO.VRPERCALTERA/100)) VRDIFEREALTE,
    GPE_VINCULOH.NRVINCULOM,
    GPE_VINCULOH.NRORG,
    TO_NUMBER(TO_CHAR(GPE_ALTESALARIO.DTALTESALARIO,'mm')) - TO_NUMBER(TO_CHAR(ESTRUTURAH.DTBASESINDICAL,'mm')) QUANTMESES

FROM GPE_ALTESALARIO
INNER JOIN GPE_VINCULOH
    ON GPE_VINCULOH.NRVINCULOM = GPE_ALTESALARIO.NRVINCULOM
    AND GPE_VINCULOH.NRORG = GPE_ALTESALARIO.NRORG
INNER JOIN ESTRUTURAH
    ON GPE_VINCULOH.NRESTRUTSIND = ESTRUTURAH.NRESTRUTURAM
    AND (GPE_VINCULOH.NRORG = ESTRUTURAH.NRORG OR ESTRUTURAH.NRORG = 0 OR ESTRUTURAH.NRORG IS NULL)
    AND GPE_ALTESALARIO.DTALTESALARIO >= ESTRUTURAH.DTBASESINDICAL
WHERE GPE_ALTESALARIO.NRTIPOALTERA = 3
    AND ESTRUTURAH.DTBASESINDICAL IS NOT NULL
    AND GPE_ALTESALARIO.DTALTESALARIO BETWEEN TO_DATE('$data_inicial') AND TO_DATE('$data_final')
    AND ESTRUTURAH.DTMESCOMPETENC BETWEEN TO_DATE('$data_inicial') AND TO_DATE('$data_final')
    AND GPE_VINCULOH.NRVINCULOM = $nrvinculom
    AND GPE_VINCULOH.NRORG = $nrorg
SQL;

        $result = \Setforms2\Shared\Connection::getInstance()->fetchAll($sql);
        return ($result)?$result:false;

    }

    /**
     * Retorna o somatório das referências do evento no item de calculo filtrado pelo vínculo e organização
     * @param string $nrvinculom
     * @param int $nrorg
     * @param \DateTime $data_inicial
     * @param \DateTime $data_final
     * @param string $nreventom
     * @param string $nrtipomoviment
     * @param string $dtmescompetenc
     * @return array|bool
     */
    public static function getSomaItemCalculo($nrvinculom, $nrorg, \DateTime $data_inicial, \DateTime $data_final, $nreventom, $nrtipomoviment, $dtmescompetenc)
    {

        $data_inicial = $data_inicial->format('d/m/Y');
        $data_final = $data_final->format('d/m/Y');

        $sql = <<<SQL
SELECT SUM(DECODE(FPA_EVENTOH.IDMEDIAVALREF, 'REFERENCIA', FPA_ITECALCFOLHA.VRREFFOLHA, FPA_ITECALCFOLHA.VREVENTOFOLHA)) VALOR,
    FPA_ITECALCFOLHA.NRVINCULOM,
    FPA_ITECALCFOLHA.NRORG
FROM FPA_CALCULOFOLHA
INNER JOIN FPA_ITECALCFOLHA
    ON FPA_ITECALCFOLHA.NRCALCULOFOLHA = FPA_CALCULOFOLHA.NRCALCULOFOLHA
    AND FPA_ITECALCFOLHA.NRORG = FPA_CALCULOFOLHA.NRORG
INNER JOIN FPA_EVENTOH
    ON FPA_ITECALCFOLHA.NREVENTOM = FPA_EVENTOH.NREVENTOM
    AND (FPA_ITECALCFOLHA.NRORG = FPA_EVENTOH.NRORG OR FPA_EVENTOH.NRORG = 0)
    AND FPA_EVENTOH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) DTMESCOMPETENC
                        FROM FPA_EVENTOH MAX_EVENTOH
                        WHERE MAX_EVENTOH.NREVENTOM = FPA_EVENTOH.NREVENTOM
                          AND MAX_EVENTOH.NRORG = FPA_EVENTOH.NRORG
                          AND MAX_EVENTOH.DTMESCOMPETENC <= '$dtmescompetenc')
WHERE FPA_ITECALCFOLHA.NREVENTOM IN ($nreventom)
    AND FPA_CALCULOFOLHA.NRTIPOMOVIMENT IN ($nrtipomoviment) --( 1, 5, 6, 9)
    AND FPA_CALCULOFOLHA.NRTPMODALIDCAL = 1
    AND FPA_CALCULOFOLHA.NROCORRECAL = 1
    AND (FPA_CALCULOFOLHA.DTOCORRENCIA BETWEEN TO_DATE('$data_inicial') AND TO_DATE('$data_final'))
    AND FPA_ITECALCFOLHA.NRVINCULOM = $nrvinculom
    AND FPA_ITECALCFOLHA.NRORG = $nrorg
GROUP BY FPA_ITECALCFOLHA.NRVINCULOM,
    FPA_ITECALCFOLHA.NRORG
SQL;

        //$result = \Setforms2\Shared\Connection::getInstance()->fetchAll($sql);
        $query = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->prepare($sql);
        $query->execute();
        $result = $query->fetchAll();
        return ($result)?$result[0]:false;

    }
}