<?php

/**
 * GepConvocadoreuniao
 *
 * This class has been auto-generated by the Doctrine ORM Framework
 *
 * @package    DbModel
 * @subpackage Model
 * @author     robertomartins - 29/07/2011 10:17:55 <development@setforms.com>
 * @version    SVN: $Id: Builder.php 6508 2009-10-14 06:28:49Z jwage $
 */
class GepConvocadoreuniao extends DaoGepConvocadoreuniao
{


    /**
     * Retorna os convocados de uma reuniao.
     *
     * @param integer $reuniao Numero da reuniao.
     * @param integer $nrorg   Numero da organizacao.
     *
     * @return Ambigous <<type>, multitype:, mixed>|boolean
     */
    public static function consultaConvocadoReuniao($reuniao ,$nrorg) {
        try {
            $obj = self::getObjectByWhere(
                'NRORG = ? AND NRCONVOCADOREUNIAO = ?',
                array(
                 $nrorg,
                 $reuniao,
                )
            );

            return $obj;
        } catch (Exception $e) {
            showClassError($e, __FUNCTION__, __LINE__);
            return false;
        }
    }


    /** ok
     * Retorna o convocado.
     *
     * @param integer $reuniao Numero da reuniao.
     * @param integer $nrorg   Numero da organizacao.
     *
     * @return Ambigous <<type>, multitype:, mixed>|boolean
     */
    public static function consultaConvocadoReuniaoByReuniao($reuniao ,$nrorg) {
        try {
            $obj = self::getObjectsByWhere(
                'NRORG = ? AND NRREUNIAO = ?',
                array(
                 $nrorg,
                 $reuniao,
                )
            );

            return $obj;
        } catch (Exception $e) {
            showClassError($e, __FUNCTION__, __LINE__);
            return false;
        }
    }


    /**
    * Exclui Convocado por Reuniao.
    *
    * @param integer $nrreuniao Numero da reuniao.
    * @param integer $nrorg     Numero da Organizacao.
    *
    * @return boolean
    */
    public static function excluiConvocadoReuniao($nrreuniao, $nrorg){
        try {
            /*
            $db = TkDbAdapter::getWorkConnection();
            $exclusao = $db->createQuery()
                ->delete('GEP_CONVOCADOREUNIAO')
                ->where("NRORG = '".$nrorg."'")
                ->addWhere("NRREUNIAO = '".$nrreuniao."'");
            $db->execute($exclusao);
            */
            $sql = "DELETE GEP_CONVOCADOREUNIAO
                    WHERE NRORG = '$nrorg'
                    AND NRREUNIAO = '$nrreuniao'";
            \Setforms2\Runtime\Connection::getInstance()->execute($sql);
        } catch(Exception $e) {
            showClassError($e, __FUNCTION__, __LINE__);
            return false;
        }
        return true;
    }


    /**
    * Exclui Convocado.
    *
    * @param integer $nrconvocadoreuniao Numero da reuniao.
    * @param integer $nrorg              Numero da Organizacao.
    *
    * @return boolean
    */
    public static function excluiConvocado($nrconvocadoreuniao, $nrorg){
        try {
            /*
            $db = TkDbAdapter::getWorkConnection();
            $exclusao = $db->createQuery()
                ->delete('GEP_CONVOCADOREUNIAO')
                ->where("NRORG = '".$nrorg."'")
                ->addWhere("NRCONVOCADOREUNIAO = '".$nrconvocadoreuniao."'");
            $db->execute($exclusao);
            */
            $sql = "DELETE GEP_CONVOCADOREUNIAO
                    WHERE NRORG = '$nrorg'
                    AND NRCONVOCADOREUNIAO = '$nrconvocadoreuniao'";
            \Setforms2\Runtime\Connection::getInstance()->execute($sql);
        } catch(Exception $e) {
            showClassError($e, __FUNCTION__, __LINE__);
            return false;
        }
        return true;
    }


    /**
     * Conta quantos parceiros foram convocados para uma reuniao.
     *
     * @param integer $nrorg     Numero da Organizacao.
     * @param integer $nrreuniao Numero da reuniao.
     *
     * @return multitype:|boolean
     */
    public static function consultaQtdParceirosConvocados($nrorg, $nrreuniao){
        try {
            /*
            $db = TkDbAdapter::getWorkConnection();
            $sql = $db->createQuery()
                ->select('COUNT(*) AS quantidade')
                ->from('GEPPAUTAPADRAO')
                ->where("NRORG = '".$nrorg."'")
                ->addWhere("NRREUNIAO = '".$nrreuniao."'");
            $qtd = $sql->execute()->getFirst()->_values['quantidade'];
            */
            $sql = "SELECT COUNT(*) AS QUANTIDADE
                    FROM GEP_CONVOCADOREUNIAO
                    WHERE NRORG = '$nrorg'
                    AND NRREUNIAO = '$nrreuniao'";

            $resultado = \Setforms2\Runtime\Connection::getInstance()->fetchAll($sql);
            $qtd = $resultado[0]['QUANTIDADE'];
            return $qtd;
        } catch (Exception $e) {
            showClassError($e, __FUNCTION__, __LINE__);
            return false;
        }
    }


    /**
     * Metodo para verificar se existe atividade apropriada.
     *
     * @param integer $nrorg     Numero da organizacao.
     * @param integer $atividade Numero da atividade.
     *
     * @return Ambigous <mixed, NULL>|boolean
     */
    public static function verificarAtividadeGerada($nrorg, $atividade){
        try {
            $obj = self::getObjectByWhere(
                'NRORG = ? AND NRATIVIDADEGERADA = ?',
                array(
                 $nrorg,
                 $atividade,
                )
            );

            return $obj;
        } catch (Exception $e) {
            showClassError($e, __FUNCTION__, __LINE__);
            return false;
        }
    }


    /**
     * Consulta total de convocados na sala.
     *
     * @param integer $nrorg Numero da organizacao.
     * @param integer $sala  Numero da sala.
     *
     * @return Ambiguous|boolean
     */
    public static function consultaTotalConvocadosSala($nrorg, $sala) {
        try {
            /*
            $db = TkDbAdapter::getWorkConnection();
            $sql = $db->createQuery()
                ->select('COUNT(*) AS TOTAL')
                ->from('GEPREUNIAO RE')
                ->addFrom('GEPCONVOCADOREUNIAO CO')
                ->where("RE.NRORG = '".$nrorg."'")
                ->addWhere("RE.NRSALA = '".$sala."'")
                ->addWhere("RE.NRREUNIAO = CO.NRREUNIAO");
            $qtd = $sql->execute()->getFirst()->_values['TOTAL'];
            */
            $sql = "SELECT COUNT(*) AS TOTAL
                    FROM GEP_REUNIAO RE,
                      GEP_CONVOCADOREUNIAO CO
                    WHERE RE.NRORG   = '$nrorg'
                    AND RE.NRSALA    = '$sala'
                    AND RE.NRREUNIAO = CO.NRREUNIAO";
            $resultado = \Setforms2\Runtime\Connection::getInstance()->fetchAll($sql);
            $qtd = $resultado[0]['TOTAL'];
            return $qtd;
        } catch (Exception $e) {
            showClassError($e, __FUNCTION__, __LINE__);
            return false;
        }
    }


    /**
     * Consulta o total de convocados na sala no periodo.
     *
     * @param integer $nrorg    Numero da organizacao.
     * @param integer $sala     Numero da sala.
     * @param string  $dtinicio Data de inicio.
     * @param string  $dtfim    Data de fim.
     *
     * @return Ambiguous|boolean
     */
    public static function consultaTotalConvocadosSalaPorPeriodo($nrorg, $sala, $dtinicio, $dtfim){
        try {
            $sql = "SELECT SUM(COUNT(CO.NRCONVOCADOREUNIAO)) QTD
                      FROM GER_SALA SA, GEP_CONVOCADOREUNIAO CO
                     WHERE CO.NRREUNIAO IN (SELECT RE.NRREUNIAO
                                           FROM GEP_REUNIAO RE
                                          WHERE ((RE.DTINICIOPLANEJADO BETWEEN '$dtinicio' AND '$dtfim')
                                             OR (RE.DTFIMPLANEJADO BETWEEN '$dtinicio' and '$dtfim'))
                                            AND RE.NRSALA = $sala
                                            AND RE.NRORG = $nrorg)
                       AND CO.NRORG = $nrorg
                       AND SA.NRSALA = $sala
                       AND SA.NRORG = CO.NRORG
                  GROUP BY CO.NRREUNIAO";
            $resultado = \Setforms2\Runtime\Connection::getInstance()->fetchAll($sql);
            $qtd = $resultado[0]['QTD'];
            return $qtd;
        } catch (Exception $e) {
            showClassError($e, __FUNCTION__, __LINE__);
            return false;
        }
    }


}
